# Partie 1 (version corrigée de l'activité capytale)

class ArbreBinaire:
    """
    ArbreBinaire() crée un arbre binaire vide (son attribut valeur est None)
    ArbreBinaire(42) crée un arbre avec un attribut valeur à 42
        et des attributs gauche et droite qui sont des ArbreBinaire vides
    """
    def __init__(self, valeur = None):
        self.valeur = valeur
        if self.valeur is not None:
            self.gauche = ArbreBinaire()
            self.droite = ArbreBinaire()

def fabrique_dico(arbre_code : ArbreBinaire, code_actuel : str, dico_code : dict) -> None:
    """
    Remplit dico_code en parcourant arbre_code, ne renvoie rien
    """
    if arbre_code.valeur == "":
        # noeud interne : appel récursif sur les deux sous-arbres en ajoutant 0 à gauche, 1 à droite
        fabrique_dico(arbre_code.gauche, code_actuel+"0", dico_code)
        fabrique_dico(arbre_code.droite, code_actuel+"1", dico_code)
    else:
        # caractère à coder : ajout dans le dictionnaire
        caractere = arbre_code.valeur
        dico_code[caractere] = code_actuel

def encode(dico_code : dict, message : str) -> str:
    """
    Renvoie le message codé en binaire avec dico_code
    """
    resultat = ""
    for lettre in message:
        resultat += dico_code[lettre]
    return resultat

def decode(arbre_code : ArbreBinaire, message_code : str) -> str:
    """
    Renvoie le message décodé à partir d'arbre_code (pas d'un dictionnaire !)
    """    
    resultat = ""
    position = arbre_code
    for bit in message_code:
        if bit=="0":
            position = position.gauche
        else:
            position = position.droite
        if position.valeur != "":
            assert position.valeur is not None
            resultat += position.valeur
            position = arbre_code
    return resultat